// RW_DPRAMDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RW_DPRAM.h"
#include "RW_DPRAMDlg.h"
//#include "WinPACSDK.h"
#include "I8120.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRW_DPRAMDlg dialog

CRW_DPRAMDlg::CRW_DPRAMDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRW_DPRAMDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRW_DPRAMDlg)
	m_RecCmd = _T("");
	m_SendCmd = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRW_DPRAMDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRW_DPRAMDlg)
	DDX_Control(pDX, IDC_BUTTON_REC_CLEAR, m_RecClear);
	DDX_Control(pDX, IDC_BUTTON_SEND_CLEAR, m_SendClear);
	DDX_Control(pDX, IDC_COMBO_SLOT_NO, m_SelectedSlotNo);
	DDX_Control(pDX, IDC_BUTTON_SEND_BTN, m_Send);
	DDX_Control(pDX, IDC_BUTTON_INIT, m_Init);
	DDX_Text(pDX, IDC_EDIT_REC_CMD, m_RecCmd);
	DDX_Text(pDX, IDC_EDIT_SEND_CMD, m_SendCmd);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRW_DPRAMDlg, CDialog)
	//{{AFX_MSG_MAP(CRW_DPRAMDlg)
	ON_BN_CLICKED(IDC_BUTTON_INIT, OnButtonInit)
	ON_BN_CLICKED(IDC_BUTTON_SEND_BTN, OnButtonSendBtn)
	ON_BN_CLICKED(IDC_BUTTON_REC_CLEAR, OnButtonRecClear)
	ON_BN_CLICKED(IDC_BUTTON_SEND_CLEAR, OnButtonSendClear)
	//}}AFX_MSG_MAP
	ON_CBN_SELCHANGE(IDC_COMBO_SLOT_NO, OnCbnSelchangeComboSlotNo)
	ON_WM_TIMER()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRW_DPRAMDlg message handlers

CString I8120W_Info;
CRITICAL_SECTION  AccessI8120W_cs; //The critical section is used to avoid mulit-accessing the same I-8120W
                                   //in the different functions or threads simultaneously. It is useless 
                                   //while the functions or threads access the I-8120W with different slot.

static int SlotNo=0;
void MyDPRAMIntt(void)
{
	BYTE DataBuf[640],InttType;
	int Ret,i;
	WORD DataLen,NodeStatus,CommStatus,VID;
	DWORD SN;

	I8120_ReadUserInttType(SlotNo, &InttType);
	if (InttType==CAN_COMM_CMD_FROM_I8120){ //Check if the main control unit got any command from the I-8120W
		EnterCriticalSection(&AccessI8120W_cs);
		//This is used to avoid mulit-accessing the same I-8120W
        //in the different functions or threads simultaneously. It is useless 
        //while the functions or threads access the I-8120W with different slot.
		Ret=I8120_ReceiveCmd(SlotNo,DataBuf,&DataLen); //Get command from I-8120W
		LeaveCriticalSection(&AccessI8120W_cs);
		if (Ret){
			if (Ret!=I8120_NoDpramCmd){ //Error happen
				I8120W_Info.Format(_T("Recevie command from I-8120W fail, error code %d\r\n"),Ret);
			}
		}
		else{
			if (DataBuf[1]=='C'){ //process [Cmd] messages from the user-defined firmware
				EnterCriticalSection(&AccessI8120W_cs);
				Ret=I8120_DPRAMReadMultiByte(SlotNo,0,DataBuf,640); //Get node information from DPRAM
				LeaveCriticalSection(&AccessI8120W_cs);
				if (Ret){
					I8120W_Info.Format(_T("Read DPRAM from I-8120W fail, error code %d\r\n"),Ret);
				}
				else{
					Ret=1; //Use this for recording if there is any node scanned by the I-8120W user-defined firmware
					for (i=1;i<64;i++){
						NodeStatus = DataBuf[i * 10];
						if (NodeStatus){ //check if the node exists or not
							Ret = 0;
							memcpy((char *)&CommStatus,&DataBuf[i*10+2],2);
							memcpy((char *)&VID,&DataBuf[i*10+4],2);
							memcpy((char *)&SN,&DataBuf[i*10+6],4);
							I8120W_Info.Format(_T("%sNode[%02d]: NodeStatus[%02X], CommStatus[%04X], VID[%04X], SN[%08X]\r\n"),
                                                  I8120W_Info,i,NodeStatus,CommStatus,VID,SN);
						}
					}
					if (Ret==1){ //There is no slave
						I8120W_Info =_T("No DeviceNet node is detected!\r\n");
					}
				}
			}
			else{
				if (DataLen<512){
					DataBuf[DataLen]=0; //End the char array
					CString Temp=DataBuf;
					I8120W_Info=I8120W_Info+Temp; //Save the received command to the variable I8120W_Info
				}
			}
		}
	}
}

BOOL CRW_DPRAMDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	m_SelectedSlotNo.InsertString(0,_T(" Slot 0"));
	m_SelectedSlotNo.InsertString(1,_T(" Slot 1"));
	m_SelectedSlotNo.InsertString(2,_T(" Slot 2"));
	m_SelectedSlotNo.InsertString(3,_T(" Slot 3"));
	m_SelectedSlotNo.InsertString(4,_T(" Slot 4"));
	m_SelectedSlotNo.InsertString(5,_T(" Slot 5"));
	m_SelectedSlotNo.InsertString(6,_T(" Slot 6"));
	m_SelectedSlotNo.InsertString(7,_T(" Slot 7"));
	m_SelectedSlotNo.SetCurSel(0);
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	m_Init.EnableWindow(TRUE);
	m_Send.EnableWindow(FALSE); //Disable the send button
	m_SendClear.EnableWindow(FALSE);
	m_RecClear.EnableWindow(FALSE);
	InitializeCriticalSection(&AccessI8120W_cs);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRW_DPRAMDlg::OnButtonInit() 
{
	// TODO: Add your control notification handler code here
	CString ErrMsg,Title;
	static BYTE SendBuf[10],RecBuf[512];
	int Ret,RetryCnt;
	static WORD RecLen;
	
	
	EnterCriticalSection(&AccessI8120W_cs);
	Ret=I8120_Init((BYTE)SlotNo); //Initiate I-8120W
	LeaveCriticalSection(&AccessI8120W_cs);
	if (Ret){
		ErrMsg.Format(_T("Initiate the I-8120W of slot %d fail, error code %d\r\n"),SlotNo,Ret);
		MessageBox(ErrMsg,MB_OK);
		return;
	}
	EnterCriticalSection(&AccessI8120W_cs);
	Ret=I8120_HardwareReset((BYTE)SlotNo); ////Reset the hardware of the I-8120W
	LeaveCriticalSection(&AccessI8120W_cs);
	if (Ret){
		ErrMsg.Format(_T("Reset I-8120W hardware of slot %d fail, error code %d\r\n"),SlotNo,Ret);
		MessageBox(ErrMsg,MB_OK);
		return;
	}


	RetryCnt = 5; //Retry 5 times to wait the completion of the initialization of the I-8120W user-defined firmware
    SendBuf[0] = 0x69; //Send cmd "i" to the I-8120W user-defined firmware to check if the firmware is ready or not
	while (RetryCnt--){
		EnterCriticalSection(&AccessI8120W_cs);
        Ret = I8120_SendReceiveCmd(SlotNo, 1, SendBuf, 1, RecBuf, &RecLen, 10);
        //get the reply by using the polling method. This function must be call before using the user ISR routine.
        //Otherwise, the reply may be anticipated by the I8120_ReceiveCmd of the user ISR routine. Then, this function 
        //will get no drpam data and return the error code.
        LeaveCriticalSection(&AccessI8120W_cs);

		if (Ret==0){
			if (RecLen < 512){
				CString Temp;
				RecBuf[RecLen] = 0; //End the char array
				m_RecCmd=RecBuf; //Show the reply from the I-8120W
                break;
            }
        }
    }
	
	if (RetryCnt==0){
		ErrMsg.Format(_T("Check the firmware initialization of the slot %d fail"),SlotNo);
		MessageBox(ErrMsg,MB_OK);
		EnterCriticalSection(&AccessI8120W_cs);
		I8120_RestoreI8120((BYTE)SlotNo);
		LeaveCriticalSection(&AccessI8120W_cs);
		return;
	}
	EnterCriticalSection(&AccessI8120W_cs);
	Ret=I8120_InstallUserISR((BYTE)SlotNo,MyDPRAMIntt); //Install the user's ISR routine
	LeaveCriticalSection(&AccessI8120W_cs);
	Title.Format(_T("DeviceNet Demo For User-defined Firmware at Slot %d"), SlotNo);
	SetWindowText(Title); //modify the title of the dialog
	m_Init.EnableWindow(FALSE);
	m_Send.EnableWindow(TRUE); //enable the send button
	m_SendClear.EnableWindow(TRUE);
	m_RecClear.EnableWindow(TRUE);
	SetTimer(12345,100,NULL);
	UpdateData(FALSE);
}

void CRW_DPRAMDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	CString ErrMsg;

	if (I8120W_Info.GetLength()){ //Check if any command stored in the variable I8120_Info
		m_RecCmd=m_RecCmd+I8120W_Info; //Put the command into the Edit box
		I8120W_Info=_T("");
		UpdateData(FALSE);
	}
	CDialog::OnTimer(nIDEvent);
}

void CRW_DPRAMDlg::OnButtonSendBtn() 
{
	// TODO: Add your control notification handler code here
	BYTE SendBuf[100];
	int Ret,StringLength;
	CString ErrMsg;

	UpdateData(); // Refresh m_SendCmd parameter
	wcstombs((char *)SendBuf,m_SendCmd.GetBuffer(100),100); //Get commands sent to I-8120W from text box
	SendBuf[100]=0;
	StringLength=strlen((char *)SendBuf);
	if (!StringLength) return; // Check command length
	EnterCriticalSection(&AccessI8120W_cs);
	Ret=I8120_SendCmd(SlotNo,(BYTE *)SendBuf,StringLength); // Send command to I-8120W
	LeaveCriticalSection(&AccessI8120W_cs);
	if (Ret){
		ErrMsg.Format(_T("Send command to I-8120W fail, error code %d\r\n"),Ret);
		MessageBox(ErrMsg,MB_OK);
	}
}

void CRW_DPRAMDlg::OnButtonRecClear() 
{
	// TODO: Add your control notification handler code here
	m_RecCmd=_T("");
	UpdateData(FALSE);	
}

void CRW_DPRAMDlg::OnButtonSendClear() 
{
	// TODO: Add your control notification handler code here
	m_SendCmd=_T("");
	UpdateData(FALSE);
}

BOOL CRW_DPRAMDlg::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	//Recover the system resource
	KillTimer(12345);
	EnterCriticalSection(&AccessI8120W_cs);
	I8120_RestoreI8120((BYTE)SlotNo);
	LeaveCriticalSection(&AccessI8120W_cs);
	DeleteCriticalSection(&AccessI8120W_cs);
	return CDialog::DestroyWindow();
}

void CRW_DPRAMDlg::OnCbnSelchangeComboSlotNo()
{
	// TODO: Add your control notification handler code here

	UpdateData(); //Updata the data from dialog
	
	if (SlotNo!=(m_SelectedSlotNo.GetCurSel())){
		EnterCriticalSection(&AccessI8120W_cs);
		I8120_RestoreI8120((BYTE)SlotNo);
		LeaveCriticalSection(&AccessI8120W_cs);
		SlotNo=m_SelectedSlotNo.GetCurSel(); //Get slot No.
		KillTimer(12345);
		SetWindowText(_T("DeviceNet Demo For User-defined Firmware")); //Modify the title of the dialog
		m_Init.EnableWindow(TRUE);
		m_Send.EnableWindow(FALSE); //Disable the send button
		m_SendClear.EnableWindow(FALSE);
		m_RecClear.EnableWindow(FALSE);
	}
}
