#include "..\..\..\Firm_Lib\Ver_120\186COMM.h"

char CmdMsg[512]; //For storing the data of received command
unsigned int CmdLen; //For store the data length of recevie command
unsigned int IsCmdFlag,ErrorFlag,StartToDemo;
void UserDPRAMIrqFunc(unsigned char INTT) //must be called
{
	int Ret;
	
	if (INTT==SEND_DPRAM_CMD){ //Check if commmand is received by using interrupt service routine
		Ret=DPRAMReceiveCmd(CmdMsg,&CmdLen); //Get command information, which is sent from WinPAC, ViewPAC, XPAC, ...
		if (!Ret){
			IsCmdFlag=1; //Got a command from host
		}
		else{
			if (Ret!=_NO_DPRAM_CMD) ErrorFlag=Ret; //Trigger the error flag, then show the error message in loop function
		}
	}
}

void UserCANIrqFunc(unsigned char INTT)   //must be called
{
  	if (INTT);//Do nothing, avoid the warnning
}

COUNTDOWNTIMER CheckTimer;
void UserInitFunc(void)    //must be called
{
	IsCmdFlag=ErrorFlag=StartToDemo=0;
	T_CountDownTimerPause(&CheckTimer); //stop a count down timer
  	Print("[Dbg]Host watchdog demo is runnung...\r\n"); //debug information for Debug port
}

unsigned int LedCnt;
void UserLoopFunc(void)    //must be called
{
	LedCnt++;
	if (LedCnt&0x4000) L2Off(); //flash L2
	else L2On();
	
	RefreshWDT();// avoid the WDT timeout
	if (IsCmdFlag){
		switch (CmdMsg[0]){// check command type
			case 'r': //the command for refreshing WDT and yellow LED
			case 'R':
				DPRAMSendCmd("[Info]Reset the yellow LED\r\n",28);
				L1Off(); //turn off yellow LED
				StartToDemo=1;
				break;
			case 'i':
			case 'I':
				DPRAMSendCmd("[Info]The timeout of the WDT is 5 secondes. Keyin 'R' to reset the WDT, any command will refresh the WDT\r\n",106);
				StartToDemo=1;
				break;
			default:
				DPRAMSendCmd("[Info]A Command is got\r\n",24);
				break;
		}
		T_CountDownTimerStart(&CheckTimer,5000); //start a count down timer
		IsCmdFlag=0;
	}
	if (StartToDemo){
		if (T_CountDownTimerIsTimeUp(&CheckTimer)){ // check if timeout or not
			L1On(); //turn off yellow LED
			StartToDemo=0;
			Print("[Dbg]Host is dead and the WDT is timeout\r\n"); //debug information for Debug port
		}
	}
	if (ErrorFlag){ // check if got a error from DPRAMReceiveCmd() or not
		Print("[Dbg]DPRAMReceiveCmd error, error code=%d\r\n",ErrorFlag); //debug information for Debug port
  		ErrorFlag=0;
	}
}