#include "..\..\..\Firm_Lib\Ver_120\186COMM.h"

char CmdMsg[512]; //For storing the data of received command
unsigned int CmdLen; //For store the data length of recevie command
unsigned int SendMsgFlag,ErrorFlag;
void UserDPRAMIrqFunc(unsigned char INTT) //must be called
{
	int Ret;
	
	if (INTT==SEND_DPRAM_CMD){ //Check if commmand is received by using interrupt service routine
		Ret=DPRAMReceiveCmd(CmdMsg,&CmdLen);
		if (!Ret){
			SendMsgFlag=1; //Trigger the flag of sending message, then send message in loop function
			CmdMsg[CmdLen]=0;
		}
		else{
			if (Ret!=_NO_DPRAM_CMD) ErrorFlag=Ret; //Trigger the error flag, then show the error message in loop function
		}
	}
}

void UserCANIrqFunc(unsigned char INTT)   //must be called
{
	if (INTT);//Do nothing, avoid the warnning
}

void UserInitFunc(void)    //must be called
{
	int Ret;
	
	SendMsgFlag=ErrorFlag=0;
  	Print("[Dbg]RxMsg demo is runnung...\r\n"); //debug information for Debug port
 
  	Ret=CANConfig(125000UL,0,0,0xffffffffUL,0x00000000UL); //Set baud to 125 kbps, and filter is "passing all messages"
  	if (Ret){
  		Print("[Dbg]Config error, error code=%d\r\n",Ret); //debug information for Debug port
  	}
}

unsigned int LedCnt;
void UserLoopFunc(void)    //must be called
{
	char Data[8],DataLen,Mode,RTR,CmdStr[200];
	int i,Ret;
	unsigned long MsgID,UpperTime,LowerTime;
	
	LedCnt++;
	if (LedCnt&0x4000) L2Off(); //flash L2
	else L2On();
	
	if (SendMsgFlag){ //Check if the flag of sending message is triggered.
		switch(CmdMsg[0]){ //Check command type
			case 'i':
			case 'I':
				DPRAMSendCmd("[Info]Keyin 'G' to get CAN message at 125 kbps baud, 'Q' to stop, 'I' to restart\r\n",82); //respond command to WinPAC, ViewPAC, XPAC, ...
				EnableSJA1000(); //Let CAN controller start to work.
				break;
			case 'G': 
			case 'g':
				Ret=GetCANMsg(&Mode,&MsgID,&RTR,&DataLen,Data,&UpperTime,&LowerTime); //Receiving CAN messages
				if (!Ret){
					sprintf(CmdStr,"[Dbg]Mode=%d,ID=%08lx,RTR=%d,DLen=%d,",Mode,MsgID,RTR,DataLen); //debug information for Debug port
					if (RTR==0 && DataLen>0){
						sprintf(&CmdStr[strlen(CmdStr)],"Data="); //debug information for Debug port
						for (i=0;i<DataLen;i++){
							sprintf(&CmdStr[strlen(CmdStr)],"%02X,",(unsigned char)Data[i]); //debug information for Debug port
						}
					}
					sprintf(&CmdStr[strlen(CmdStr)],"Time=%lu%lu.%lu ms\r\n",UpperTime,LowerTime/10,(LowerTime-LowerTime/10*10)); //debug information for Debug port
					Print("%s",CmdStr);
					DPRAMSendCmd(CmdStr,strlen(CmdStr));
				}
				else{
					if (Ret!=_RX_SOFT_BUF_EMPTY){
						sprintf(CmdStr,"[Dbg]Stop to receive data because of receiving error, error code=%d\r\n",Ret); //debug information for Debug port
	 					Print("%s",CmdStr);
	 					DPRAMSendCmd(CmdStr,strlen(CmdStr));
	 					DisableSJA1000();
					}
					else{
						Print("[Dbg]Rx buffer is empty\r\n");
						DPRAMSendCmd("[Info]Rx buffer is empty\r\n",26);
					}
				}
				break;
			case 'q':
			case 'Q':
				DisableSJA1000();
				Print("[Dbg]Stop to receive data\r\n"); //debug information for Debug port
				DPRAMSendCmd("[Info]Stop to receive data\r\n",28); //respond command to WinPAC, ViewPAC, XPAC, ...
				break;
			default:
				DPRAMSendCmd("[Err]Host command is not support\r\n",34); //respond command to WinPAC, ViewPAC, XPAC, ...
				Print("[Dbg]Host command [0x%02X] is not support\r\n",CmdMsg[0]); //debug information for Debug port
				break;
		}
		SendMsgFlag=0;
	}
	RefreshWDT(); // avoid the WDT timeout
}