#include "..\..\..\Firm_Lib\Ver_120\186COMM.h"

char CmdMsg[512]; //For storing the data of received command
unsigned int CmdLen; //For store the data length of recevie command
unsigned int SendMsgFlag,ErrorFlag;
void UserDPRAMIrqFunc(unsigned char INTT) //must be called
{
	int Ret;
	
	if (INTT==SEND_DPRAM_CMD){ //Check if commmand is received by using interrupt service routine
		Ret=DPRAMReceiveCmd(CmdMsg,&CmdLen); //Get command information, which is sent from WinPAC, ViewPAC, XPAC, ...
		if (!Ret){
			SendMsgFlag=1; //Trigger the flag of sending message, then send message in loop function
		}
		else{
			if (Ret!=_NO_DPRAM_CMD) ErrorFlag=Ret; //Trigger the error flag, then show the error message in loop function
		}
	}
}

void UserCANIrqFunc(unsigned char INTT)   //must be called
{
	if (INTT);//Do nothing, avoid the warnning
}

void UserInitFunc(void)    //must be called
{
	int Ret;
	SendMsgFlag=ErrorFlag=0;
  	Print("TxMsg demo is runnung...\r\n"); //debug information for Debug port
  	SendMsgFlag=ErrorFlag=0; //initial the golbal variable
  	Ret=CANConfig(125000UL,0,0,0xffffffffUL,0x00000000UL); //Set baud to 125K, and the filter is "passing all messages"
  	if (Ret){
  		Print("Config error, error code=%d\r\n",Ret); //debug information for Debug port
  	}
  	EnableSJA1000(); //Let SJA1000 start to work.
}

unsigned int LedCnt;
void UserLoopFunc(void)    //must be called
{
	char Data[8],TempData[3],DataLen,Mode,RTR,i,ReadyToSend=0,*endptr;
	int Ret;
	unsigned long MsgID,LowMsgID;
	
	LedCnt++;
	if (LedCnt&0x4000) L2Off(); //flash L2
	else L2On();
	
	if (SendMsgFlag){ //Check if the flag of sending message is triggered.
		switch(CmdMsg[0]){ //Check command type
			case 'i':
			case 'I':
				DPRAMSendCmd("[Info]Ready to send messages on 125 kbps baud\r\n",47); //send information to WinPAC, ViewPAC, XPAC, ...
				break;
			case 'T': //send 11-bit ID message with RTR, command format is IIIL (III means the hax value of ID, L means datalen)	
				Print("[Dbg]Got a command with header of 'T'\r\n"); //debug information for Debug port
				if (CmdLen>4){//Check CmdLen is OK or not
					Mode=0;
					RTR=1;  
					DataLen=(CmdMsg[4]-0x30); //Get datalen (from ascii to value)
					if (DataLen>8) DataLen=8;
					CmdMsg[4]=0;
					MsgID=strtoul(&CmdMsg[1],&endptr,16); //Get message ID (from ascii to value)
					ReadyToSend=1;
					DPRAMSendCmd("[Info]Send a CAN 2.0A RTR frame OK\r\n",36); //respond command to WinPAC, ViewPAC, XPAC, ...
				}
				else{
					DPRAMSendCmd("[Info]Send a CAN 2.0A RTR frame error\r\n",39); //respond command to WinPAC, ViewPAC, XPAC, ...
				}
				break;
			case 't': //send 11-bit ID message, command format is IIILDDDDDD...(DD means a byte of data with hex format)
				Print("[Dbg]Got a command with header of 't'\r\n"); //debug information for Debug port
				if (CmdLen>4){//Check CmdLen is OK or not
					Mode=0;
					RTR=0;
					DataLen=(CmdMsg[4]-0x30);
					if (DataLen>8) DataLen=8; //Get datalen (from ascii to value)
					if (CmdLen<=(4+DataLen*2)){
						DPRAMSendCmd("[Info]Send a CAN 2.0A data frame error\r\n",40); //respond command to WinPAC, ViewPAC, XPAC, ...
						break; //CmdLen is not enough for message data
					}
					CmdMsg[4]=0;
					MsgID=strtoul(&CmdMsg[1],&endptr,16); //Get message ID (from ascii to value)
					TempData[2]=0;
					for (i=0;i<DataLen;i++){ //Get data (from ascii to value)
						TempData[0]=CmdMsg[5+i*2];
						TempData[1]=CmdMsg[5+i*2+1];
						Data[i]=(char)strtoul(TempData,&endptr,16);
					}
					ReadyToSend=1;
					DPRAMSendCmd("[Info]Send a CAN 2.0A data frame OK\r\n",37); //respond command to WinPAC, ViewPAC, XPAC, ...
				}
				else{
					DPRAMSendCmd("[Info]Send a CAN 2.0A data frame error\r\n",40); //respond command to WinPAC, ViewPAC, XPAC, ...
				}
				break;
			case 'E': //send 29-bit ID message with RTR, command format is IIIIIIIIL.
				Print("[Dbg]Got a command with header of 'E'\r\n"); //debug information for Debug port
				if (CmdLen>9){//Check CmdLen is OK or not
					Mode=1;
					RTR=1;
					DataLen=(CmdMsg[9]-0x30); //Get datalen (from ascii to value)
					if (DataLen>8) DataLen=8;
					CmdMsg[9]=0;
					LowMsgID=strtoul(&CmdMsg[5],&endptr,16); //Get message ID (from ascii to value)
					CmdMsg[5]=0;
					MsgID=strtoul(&CmdMsg[1],&endptr,16); //avoid the bug of strtoul() of TC++ 1.01
					MsgID=(MsgID<<16)+LowMsgID;
					ReadyToSend=1;
					DPRAMSendCmd("[Info]Send a CAN 2.0B RTR frame OK\r\n",36); //respond command to WinPAC, ViewPAC, XPAC, ...
				}
				else{
					DPRAMSendCmd("[Info]Send a CAN 2.0B RTR frame error\r\n",39); //respond command to WinPAC, ViewPAC, XPAC, ...
				}
				break;			
			case 'e': //send 29-bit ID message, command format is IIIIIIIILDDDDDD...
				Print("[Dbg]Got a command with header of 'e'\r\n"); //debug information for Debug port
				if (CmdLen>9){//Check CmdLen is OK or not
					Mode=1;
					RTR=0;
					DataLen=(CmdMsg[9]-0x30); //Get datalen (from ascii to value)
					if (DataLen>8) DataLen=8;
					if (CmdLen<=(9+DataLen*2)){
						DPRAMSendCmd("[Info]Send a CAN 2.0B data frame error\r\n",40); //respond command to WinPAC, ViewPAC, XPAC, ...
						break; //CmdLen is not enough for message data
					}
					CmdMsg[9]=0;
					LowMsgID=strtoul(&CmdMsg[5],&endptr,16); //Get message ID (from ascii to value)
					CmdMsg[5]=0;
					MsgID=strtoul(&CmdMsg[1],&endptr,16); //avoid the bug of strtoul() of TC++ 1.01
					MsgID=(MsgID<<16)+LowMsgID;
					TempData[2]=0;
					for (i=0;i<DataLen;i++){ //Get data (from ascii to value)
						TempData[0]=CmdMsg[10+i*2];
						TempData[1]=CmdMsg[10+i*2+1];
						Data[i]=(char)strtoul(TempData,&endptr,16);
					}
					ReadyToSend=1;
					DPRAMSendCmd("[Info]Send a CAN 2.0B data frame OK\r\n",37); //respond command to WinPAC, ViewPAC, XPAC, ...
				}
				else{
					DPRAMSendCmd("[Info]Send a CAN 2.0B data frame error\r\n",40); //respond command to WinPAC, ViewPAC, XPAC, ...
				}
				break;
			default:
				DPRAMSendCmd("[Err]Host command is not support\r\n",34); //respond command to WinPAC, ViewPAC, XPAC, ...
				Print("[Dbg]Host command [0x%02X] is not support\r\n",CmdMsg[0]); //debug information for Debug port
				break;
		}
		RefreshWDT();// avoid the WDT timeout
		if (ReadyToSend){ //Check if need to send message or not
			Ret=SendCANMsg(Mode,MsgID,RTR,DataLen,Data);
			if (Ret){
				Print("[Dbg]SendCANMsg error, error code=%d\r\n",Ret); //debug information for Debug port
			}
			else{
				Print("[Dbg]Send one CAN message\r\n"); //debug information for Debug port
		  }
			ReadyToSend=0;
		}
		SendMsgFlag=0;
	}
	if (ErrorFlag){ // check if got a error from DPRAMReceiveCmd() or not
		Print("[Dbg]DPRAMReceiveCmd error, error code=%d\r\n",ErrorFlag); //debug information for Debug port
  	ErrorFlag=0;
	}
}